Components.utils.import("resource://app/modules/gloda/mimemsg.js");
Components.utils.import("resource://app/modules/gloda/connotent.js");

if(!com.ktsystems.subswitch.SubSwitchMain) com.ktsystems.subswitch.SubSwitchMain={};

com.ktsystems.subswitch.SubSwitchMain = {
    rdi_loadStatus : false,
    rdi_initStatus : false,
    rdi_isRD : false,
    loadRDfromEmail : true,
    addRDtoEmail : true,
    rdi_curr : null,
    
    init : function() {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        if (subMain.rdi_initStatus)
            return;
        var prefs = com.ktsystems.subswitch.Const.subswitch_prefs;
        var defaultRD;
        var offbydefault, contextmenu;
        var initdelay;

        try {
            defaultRD = parseInt(prefs.getCharPref("defaultrd"));
            offbydefault = prefs.getBoolPref("offbydefault");
            contextmenu = prefs.getBoolPref("contextmenu");
            subMain.loadRDfromEmail = prefs.getBoolPref("loadRDfromEmail");
            subMain.addRDtoEmail = prefs.getBoolPref("addRDtoEmail");
        } catch (e) {
            com.ktsystems.subswitch.Utils.dumpStr('subMain.init-> '+e);
            defaultRD = -1;
            offbydefault = false;
            contextmenu = true;
            initdelay = 1000;
        }

        var ctxmenu = document.getElementById("subjects_prefix_switchContext");
        ctxmenu.setAttribute("hidden", !contextmenu);
        var ctxmenuSep = document.getElementById("subjects_prefix_switchContextSeparator");
        ctxmenuSep.setAttribute("hidden", !contextmenu);
        
/*
 *                com.ktsystems.subswitch.SubSwitchMain.createSubToolbar();
 */
        setTimeout("com.ktsystems.subswitch.SubSwitchMain.delayedInit(" + defaultRD + ", " + offbydefault + ")", initdelay);
        
        subMain.rdi_initStatus = true;
    },

    subjects_prefix_switch : function() {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        var subjectElement = GetMsgSubjectElement();
        var wasPrefix = subMain.rdi_isRD;
        subjectElement.editor.beginTransaction();

        com.ktsystems.subswitch.Utils.dumpStr('XXXXXXXX->' + subMain.rdi_curr + ' ' + subMain.rdi_isRD);
        if (subMain.searchRD(subjectElement)) {
            subMain.removeRD(subjectElement);
        }
        if (wasPrefix || !subMain.rdi_curr) {
            subMain.loadNextPrefix();
        }
        if (!subMain.rdi_isRD && subMain.rdi_curr != null) {
            subMain.insertRD(subjectElement, subMain.rdi_curr);
        }
        
        com.ktsystems.subswitch.Utils.dumpStr('XXXXXXXX->' + subMain.rdi_curr + ' ' + subMain.rdi_isRD);
        
        SetComposeWindowTitle();
        subjectElement.editor.endTransaction();
    },

    on_off_prefix : function() {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        var subjectElement = GetMsgSubjectElement();
        var wasPrefix = subMain.rdi_isRD;
        subjectElement.editor.beginTransaction();

        if (!subMain.rdi_isRD && subMain.rdi_curr != null) {
            subMain.insertRD(subjectElement, subMain.rdi_curr);
        } else {
            if (subMain.searchRD(subjectElement)) {
                subMain.removeRD(subjectElement);
		    }
        }
        
        SetComposeWindowTitle();
        subjectElement.editor.endTransaction();
    },

    loadNextPrefix : function() {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        var nextPrefix;
        var prefixes = subMain.loadRDProperty();
        if (!subMain.rdi_curr)  {
            nextPrefix = prefixes[0];
        } else {
            var idx = prefixes.indexOf(subMain.rdi_curr) + 1;
            if (idx <= prefixes.length)  {
                nextPrefix = prefixes[idx];
            } else {
                nextPrefix = null;
            }
        }
        subMain.rdi_curr = nextPrefix;
        com.ktsystems.subswitch.Utils.dumpStr('loadNextPrefix->' + nextPrefix);
    },

    searchRD : function(subjectElement) {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        if (!subMain.rdi_curr)
            return false;
        
        var indexOf = subjectElement.value.indexOf(subMain.rdi_curr.rd);
        return (indexOf > -1);
    },

    removeRD : function(subjectElement) {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        var start = subjectElement.value.indexOf(subMain.rdi_curr.rd);
        var len = subMain.rdi_curr.rd.length
        
        subjectElement.value = 
            // 0 - RD
            subjectElement.value.substring(0, start) 
            // RD - koniec z usuniecie spacji po RD
            + (subjectElement.value.substring(start+len).charAt(0) == ' '
                ? subjectElement.value.substring(start + len + 1)
                : subjectElement.value.substring(start + len));
        
       subMain.rdi_isRD = false;
    },

    insertRD : function(subjectElement, rd) {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        subjectElement.editor.beginningOfDocument();
        subjectElement.value = rd.rd + ' ' + subjectElement.value;
        
        subMain.rdi_curr = rd;
        subMain.rdi_isRD = true;

        com.ktsystems.subswitch.Utils.dumpStr('insertRD->' + rd.rd + ' ' +rd.description);
    },

    loadRD : function(idx, del) {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        var rd = subMain.loadRDProperty()[idx];
        
        var subjectElement = GetMsgSubjectElement();
        var currentEditor = subjectElement.editor;
        var initialRange = currentEditor.selection.getRangeAt(0).cloneRange();
        var hasRD = subMain.searchRD(subjectElement);
        currentEditor.beginTransaction();

        if (hasRD && del) {
            subMain.removeRD(subjectElement);
        }
        subMain.insertRD(subjectElement, rd);
        
        SetComposeWindowTitle();
        currentEditor.endTransaction();

        currentEditor.selection.removeAllRanges();
        currentEditor.selection.addRange(initialRange);

        subMain.sanitize();
    },

    sanitize : function()  {
        com.ktsystems.subswitch.SubSwitchMain.rdi_initStatus = false;
    },

    ensurePrefs : function() {
        var subConst = com.ktsystems.subswitch.Const;
        for (var i = 0; i < subConst.CONFIGURATION_IDS.length; i++) {
            if (subConst.subswitch_prefs.getPrefType(subConst.CONFIGURATION_IDS[i])
                    == subConst.subswitch_prefs.PREF_INVALID)  {
                com.ktsystems.subswitch.Utils.openOptions(true);
                return;
             }
        }
     },

    onLoad : function() {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        if (subMain.rdi_loadStatus)
            return;
        subMain.ensurePrefs();
        subMain.init();
        
        subMain.rdi_loadStatus = true;
    },

    delayedInit : function(defaultRD, offbydefault) {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        com.ktsystems.subswitch.Utils.dumpStr('delayedInit ->' + defaultRD + ' ' +offbydefault);
        var hasDefaultRD = defaultRD > -1;
        if (hasDefaultRD && !subMain.loadRDfromEmail) {
            subMain.initWithDefault(defaultRD, offbydefault);
        }
        if(subMain.loadRDfromEmail) {
            subMain.loadOriginalMsgSSHeader(defaultRD, offbydefault);
        }
    },

    initWithDefault : function(defaultRD, offbydefault) {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        subMain.rdi_curr = subMain.loadRDProperty()[defaultRD];
        if (!offbydefault && subMain.rdi_curr) {
            subMain.loadRD(defaultRD, subMain.rdi_initStatus);
        }
    },

    initMenuPopup : function(element) {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        var menuPopup = document.getElementById("subjects_prefix_switchMenuPopup-" + element);

        com.ktsystems.subswitch.Utils.removeMenuItems(menuPopup);

        if (element != "toolbar") {
            subMain.insertOnOffItem(menuPopup,
                com.ktsystems.subswitch.Utils.getLocalizedMessage("menuItem.onOff"),
                com.ktsystems.subswitch.Utils.getLocalizedMessage("toolTip.onOff"));
            menuPopup.appendChild(document.createElement("menuseparator"));
        }

        /*
         if (element == "menu" || element == "context") {
            subMain.insertOnOffItem(menuPopup,
                com.ktsystems.subswitch.Utils.getLocalizedMessage("menuItem.onOff"),
                com.ktsystems.subswitch.Utils.getLocalizedMessage("toolTip.onOff"));
            menuPopup.appendChild(document.createElement("menuseparator"));
        } else if (element == "subtoolbar") {
            subMain.insertOnOffItem(menuPopup,
                "",
                com.ktsystems.subswitch.Utils.getLocalizedMessage("toolTip.onOff"));
        }
        */
        var rdData = subMain.loadRDProperty();

        for (var i = 0; i < rdData.length; i++) {
            subMain.insertMenuItem(menuPopup, rdData[i].description, rdData[i].rd, i);
        }

/*
 *                if (element != "subtoolbar") {
*/
            if (rdData.length > 0) {
                menuPopup.appendChild(document.createElement("menuseparator"));
            }
        
            subMain.insertOptionsItem(menuPopup,
                com.ktsystems.subswitch.Utils.getLocalizedMessage("menuItem.options"),
                com.ktsystems.subswitch.Utils.getLocalizedMessage("toolTip.enterOptions"));
/*
 *                }
 */
   },

    loadRDProperty : function() {
        return com.ktsystems.subswitch.PrefixesListSingleton.getInstance().getPrefixesList();
    },

    insertMenuItem : function(menu, label, tooltip, idx) {
        var item = com.ktsystems.subswitch.Utils.createMenuItem("subjects_prefix_switch_RD_" + idx, label, tooltip, "com.ktsystems.subswitch.SubSwitchMain.loadRD(" + idx + ", true); event.stopPropagation();");
		menu.appendChild(item);
    },

    insertOptionsItem : function(menu, label, tooltip) {
        var item = com.ktsystems.subswitch.Utils.createMenuItem("subjects_prefix_switch_openOptions", label, tooltip, "com.ktsystems.subswitch.Utils.openOptions(false); event.stopPropagation();");
		menu.appendChild(item);
    },

    insertOnOffItem : function(menu, label, tooltip) {
        var item = com.ktsystems.subswitch.Utils.createMenuItem("subjects_prefix_switch_onOff",  label, tooltip, "com.ktsystems.subswitch.SubSwitchMain.on_off_prefix(); event.stopPropagation();");
		menu.appendChild(item);
    },

	loadOriginalMsgSSHeader : function(defaultRD, offbydefault) {
        com.ktsystems.subswitch.Utils.dumpStr('-> loadOriginalMsgSSHeader; defaultRD = '+offbydefault+'; defaultRD = '+offbydefault);
        let messenger = Components.classes["@mozilla.org/messenger;1"].createInstance(Components.interfaces.nsIMessenger);
        let msgURI = gMsgCompose.originalMsgURI;
        com.ktsystems.subswitch.Utils.dumpStr('loadOriginalMsgSSHeader; originalMsgURI->'+msgURI);
        if (msgURI) {
            let msgHdr = messenger.messageServiceFromURI(msgURI).messageURIToMsgHdr(msgURI);

            if (com.ktsystems.subswitch.SubSwitchMain.isAddressOnIgnoreList(msgHdr.author) != true) {
                try {
                    MsgHdrToMimeMessage(msgHdr, null, function(aMsgHdr, aMimeMsg) {
                        var subMain = com.ktsystems.subswitch.SubSwitchMain;
                        com.ktsystems.subswitch.Utils.dumpStr('-> MsgHdrToMimeMessage; aMimeMsg = '+aMimeMsg);
                        if (aMimeMsg == null) /* shouldn't happen, but sometimes does? */
                            return;

                        let item = subMain.findSubSwitchHeader(aMimeMsg);

                        if (item != null) {
                            subMain.rdi_curr = item;
                            subMain.rdi_isRD = true;
                        } else {
                            subMain.initWithDefault(defaultRD, offbydefault);
                        }
                        com.ktsystems.subswitch.Utils.dumpStr('<- MsgHdrToMimeMessage; item = '+item);
                     });
                } catch (e if e.result == Components.results.NS_ERROR_FAILURE) {
                    com.ktsystems.subswitch.Utils.dumpStr('loadOrgMsg; no ssHeader ->' + e);
                }
            }
        } else {
            com.ktsystems.subswitch.SubSwitchMain.initWithDefault(defaultRD, offbydefault);
        }
        com.ktsystems.subswitch.Utils.dumpStr('<- loadOriginalMsgSSHeader');
    },

    isAddressOnIgnoreList : function(author) {
        com.ktsystems.subswitch.Utils.dumpStr('-> isAddressOnIgnoreList; author = '+author);
        var result = false;
        com.ktsystems.subswitch.Utils.dumpStr(author);
        var ignoreList = com.ktsystems.subswitch.Const.subswitch_prefs.
                getComplexValue("discoveryIgnoreList", Components.interfaces.nsISupportsString).data.split(";");

        if (author.charAt(0) == "\"" && author.charAt(author.length - 1) == "\"")
            author = author.substring(1, author.length - 1);
        if (author.indexOf(">") > -1) {
            let authorStripRegEx = new RegExp("(" + com.ktsystems.subswitch.Const.rx_user + "\@" + com.ktsystems.subswitch.Const.rx_domain + ")");
            let m = authorStripRegEx.exec(author);
            if (m != null) {
                author = m[0];
            }
        }
        com.ktsystems.subswitch.Utils.dumpStr(author);
        
        if (ignoreList.length > 0) {
            var validate = new RegExp(com.ktsystems.subswitch.Const.rx);
            var match;
            if (validate.test(author)) {
                for (var j = 0; j < ignoreList.length; j++) {
                    if (ignoreList[j].indexOf("?") > -1) {
                        let ignoreTriggerRegEx = new RegExp(ignoreList[j].split("?").join(com.ktsystems.subswitch.Const.rx_wildcard));
                        com.ktsystems.subswitch.Utils.dumpStr(">>>"+ignoreList[j].split("?").join(com.ktsystems.subswitch.Const.rx_wildcard));
                        match = ignoreTriggerRegEx.test(author);
                    } else {
                        match = (ignoreList[j].toLowerCase() == author.toLowerCase());
                    }

                    if (match) {
                        result = true;
                        break;
                    }
                }
            }
        }

        com.ktsystems.subswitch.Utils.dumpStr('<- isAddressOnIgnoreList; result = '+result);
        return result;
    },

    findSubSwitchHeader : function(aMimeMsg) {
        com.ktsystems.subswitch.Utils.dumpStr('-> findSubSwitchHeader; aMimeMsg = '+aMimeMsg);
        let ssKey, ssDesctiption;
        let remotePrefixItem;
        let ssHeader = aMimeMsg.get(com.ktsystems.subswitch.Const.SUBSWITCH_MIME_HEADER);
        com.ktsystems.subswitch.Utils.dumpStr('parseSubSwitchMimeHeader; ssHeader ->'+ssHeader);

        if (ssHeader) {
            let ssStrings = ssHeader.split(';');
            ssDesctiption = ssStrings[0].trim();
            ssKey = ssStrings[1].trim();
        } else {
            let discoveryPattern = com.ktsystems.subswitch.Const.subswitch_prefs.getCharPref("discoveryItemPattern");
            let subject = aMimeMsg.get("Subject");
            let re = new RegExp(discoveryPattern);
            let m = re.exec(subject);
            if (m != null) {
                ssKey = m[0];
                ssDesctiption = m[0];
            }
        }

        if (ssKey != null) {
            var subMain = com.ktsystems.subswitch.SubSwitchMain;
            remotePrefixItem = new com.ktsystems.subswitch.PrefixItem(ssDesctiption, ssKey);
            com.ktsystems.subswitch.Utils.dumpStr('loadOriginalMsgSSHeader; dopasowanie prefiksu remoteSP ->'+remotePrefixItem);

            let idx = subMain.loadRDProperty().indexOf(remotePrefixItem);
            let found = (idx >= 0);

            if (!found) {
                if (!subMain.displayConfirm(remotePrefixItem)) {
                    remotePrefixItem = null;
                }
            } else {
                remotePrefixItem = subMain.loadRDProperty()[idx];
            }
        }

        com.ktsystems.subswitch.Utils.dumpStr('<- findSubSwitchHeader; remotePrefixItem = '+remotePrefixItem);
        return remotePrefixItem;
    },

    displayConfirm : function (remotePrefixItem) {
        var strbundle = document.getElementById("subjects_prefix_switch.locale");

        var title = strbundle.getString("discovery.confirmTitle");
        var msg = strbundle.getString("discovery.confirmMessage");
        var header = strbundle.getString("discovery.confirmHeader");
        var params = Components.classes["@mozilla.org/embedcomp/dialogparam;1"].createInstance(Components.interfaces.nsIDialogParamBlock);
        params.SetNumberStrings(30);
        
        params.SetString(0, msg);
        params.SetString(2, "question-icon");
        params.SetString(3, header);
        params.SetString(12, title);
        
        params.SetString(20, remotePrefixItem.rd);
        params.SetString(21, remotePrefixItem.description);

        window.openDialog("chrome://subjects_prefix_switch/content/prefix_found.xul", null,
            "chrome,centerscreen,modal,dialog,resizable=no", params);

        remotePrefixItem.rd = params.GetString(20);
        remotePrefixItem.description = params.GetString(21);
            
        return params.GetInt(0) == 0 ? true : false;
    },

    onSend : function() {
        var subMain = com.ktsystems.subswitch.SubSwitchMain;
        com.ktsystems.subswitch.Utils.dumpStr('-> onSend; addRDtoEmail = '+subMain.addRDtoEmail);
        if (subMain.addRDtoEmail) {
            try {
                gMsgCompose.compFields.otherRandomHeaders += com.ktsystems.subswitch.Const.SUBSWITCH_MIME_HEADER + ": " + 
                        subMain.rdi_curr.description + "; " + subMain.rdi_curr.rd +" \r\n";
                com.ktsystems.subswitch.Utils.dumpStr(gMsgCompose.compFields.otherRandomHeaders);
            } catch (ex) {
                com.ktsystems.subswitch.Utils.dumpStr ("ERROR: Cannot add current RD to message\n" + ex + "\r\n");
            }
        }
        com.ktsystems.subswitch.Utils.dumpStr('<- onSend');
/*    },

    createSubToolbar : function() {
        var subtoolbar = document.getElementById("subjects_prefix_switchMenuPopup-subtoolbarButton");
        var ms = document.getElementById("msgSubject");

        alert(subtoolbar);
        alert(ms.parentNode.localName);
        alert(ms.parentNode.firstChild.localName);

        ms.parentNode.insertBefore(subtoolbar, ms.parentNode.firstChild);
*/
    }
};

window.addEventListener("compose-send-message", com.ktsystems.subswitch.SubSwitchMain.onSend, true)
window.addEventListener("load", com.ktsystems.subswitch.SubSwitchMain.onLoad, true);
window.addEventListener("compose-window-close", com.ktsystems.subswitch.SubSwitchMain.sanitize, true);
window.addEventListener("compose-window-reopen", com.ktsystems.subswitch.SubSwitchMain.init, true);
